/* src/chaninfo.c - Lire les informations  propos d'un salon
 *
 * Copyright (C) 2002-2005 David Cortier  <Cesar@irc.jeux.fr>
 *                         Romain Bignon  <Progs@kouak.org>
 *                         Benjamin Beret <kouak@kouak.org>
 *
 * site web: http://sf.net/projects/scoderz/
 *
 * Services pour serveur IRC. Support sur IrcProgs et IRCoderz
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * $Id: chaninfo.c,v 1.44 2005/08/13 18:42:31 romexzf Exp $
 */

#include "main.h"
#include "outils.h"
#include "ban.h"
#include "cs_cmds.h"
#include "admin_chan.h"
#include "hash.h"

/*
 * chaninfo #salon
 */
int chaninfo(aNick *nick, aChan *chan, int parc, char **parv)
{
	aNChan *netchan = chan->netchan;
	int can_see = (nick->user && (IsAdmin(nick->user) || GetAccessIbyUserI(nick->user, chan)));

	if(netchan && HasMode(netchan, C_MSECRET | C_MPRIVATE) /* salon +s ou +p */
		&& !can_see && !GetJoinIbyNC(nick, netchan)) /* ET ni admin/accs, ni prsent */
			return csntc(nick, GetReply(nick, L_YOUNOACCESSON), chan->chan);

	csntc(nick, GetReply(nick, L_INFO_ABOUT), parv[1]);
	csntc(nick, GetReply(nick, L_CIOWNER), chan->owner ? chan->owner->user->nick : "Aucun",
		UNDEF(chan->creation_time));
	csntc(nick, GetReply(nick, L_CIDESCRIPTION), chan->description);

	if(can_see || !HasDMode(chan, C_MKEY))
		csntc(nick, GetReply(nick, L_CIDEFMODES), GetCModes(chan->defmodes));

	csntc(nick, GetReply(nick, L_CIDEFTOPIC), chan->deftopic);
	if(can_see && chan->motd) csntc(nick, GetReply(nick, L_CIMOTD), chan->motd);
	csntc(nick, GetReply(nick, L_CICHANURL), chan->url);

	csntc(nick, GetReply(nick, L_CIOPTIONS), GetChanOptions(chan));
	csntc(nick, GetReply(nick, L_CIBANLVL), chan->banlevel, GetBanType(chan));

	csntc(nick, GetReply(nick, L_CICHMODESLVL), chan->cml,
			chan->bantime ? duration(chan->bantime) : "Aucun");

	if(CSetWelcome(chan) && *chan->welcome) csntc(nick, GetReply(nick, L_CIWELCOME), chan->welcome);
	if(IsAnAdmin(nick->user)) show_suspend(nick, chan);

	if(netchan)
	{
		csntc(nick, GetReply(nick, L_CIACTUALTOPIC), netchan->topic);
		if(can_see || !HasMode(netchan, C_MKEY) || GetJoinIbyNC(nick, netchan))
			csntc(nick, GetReply(nick, L_CIACTUALMODES),
				netchan->modes.modes ? GetCModes(netchan->modes) : "Aucun");
		if(IsAnAdmin(nick->user)) whoison(nick, chan, parc, parv);
	}

	return 1;
}
